#!/usr/bin/python
# -*- coding: UTF-8 -*-
#
#Program ID  : WAV_tag_for_iTunes
#Autor       : Yutaka KAWAGUCHI Mailto:yutakk@yahoo.co.jp
#Create      : 2013/08/08 Version 0.98
#Update      : 2013/08/20 Version 1.00

import sys
import re
import urllib

wav_count = 0
not_wav_count = 0
playlist = 0
tracks = 0
track_key = ''
no_add = {}
v = {}
block = []
wav_flag = 0
form_string = '\t\t\t<key>%s</key><string>%s</string>'
form_integer = '\t\t\t<key>%s</key><integer>%d</integer>'
in_filename = 'Library.xml'
out_filename = 'WAV.xml'

print '\n=======[WAV_tag_for_iTunes]========'
try:
	in_file = open(in_filename, 'r')
except IOError, (errno, msg):
	print >> sys.stderr, 'cannot open "%s"' % in_filename
	print >> sys.stderr, '  errno: [%d] msg: [%s]' % (errno, msg)
	raw_input()
	sys.exit(1)
try:
	out_file = open(out_filename, 'w')
except IOError, (errno, msg):
	print >> sys.stderr, 'cannot open "%s"' % out_filename
	print >> sys.stderr, '  errno: [%d] msg: [%s]' % (errno, msg)
	raw_input()
 	sys.exit(1)
for rec in in_file:
	key = ''
	m = re.match(r'[^<]*(<.*>)',rec)
	if m is not None:
		key = m.group(1)
	if key == '<key>Playlists</key>':
		print >> out_file, rec,
		playlist = 1
		array = 0
	elif playlist == 1:
		if key == '<array>':
			array += 1
			if array == 1:
				print >> out_file, rec,
		elif key == '</array>':
			array -= 1
			if array == 0:
				print >> out_file, rec,
				playlist = 0
	elif key == '<key>Tracks</key>':
		print >> out_file, rec,
		tracks = 1
		dict = 0
	elif tracks == 1:
		if key == '<dict>':
			dict += 1
			if dict == 1:
				print >> out_file, rec,
			else:
				wav_flag = 0
				no_add = {'Name':0,'Artist':0,'Album':0,'Track Number':0,'Disc Number':0}
				v = {'Name':'','Artist':'','Album':'','Track Number':'','Disc Number':''}
				block = []
				block.append(track_key)
				block.append(rec)
		elif key == '</dict>':
			dict -= 1
			if dict == 0:
				print >> out_file, rec,
				tracks = 0
			else:
				block.append(rec)
				if wav_flag != 0:
					wav_count += 1
					for work in block:
						m = re.match(r'[^<]*<key>Name</key>',work)
						if m is not None:
							print >> out_file, form_string % ('Name',v['Name'])
							if no_add['Artist'] != 1:
								print >> out_file, form_string % ('Artist',v['Artist'])
							if no_add['Album'] != 1:
								print >> out_file, form_string % ('Album',v['Album'])
							if no_add['Track Number'] != 1:
								print >> out_file, form_integer % ('Track Number',int(v['Track Number']))
							if no_add['Disc Number'] != 1:
								print >> out_file, form_integer % ('Disc Number',int(v['Disc Number']))
						else:
							print >> out_file, work,
				else:
					not_wav_count += 1
		else:
			m = re.match(r'[^<]*<key>[0-9]+</key>',rec)
			if m is not None:
				track_key = rec
			else:
				m = re.match(r'[^<]*<key>(.*)</key><.*>(.*)</.*>',rec)
				if m is not None:
					key = m.group(1)
					value = m.group(2)
					if key == 'Name':
						m = re.match(r'^([0-9][0-9]*)-([0-9][0-9]*) (.*)$',value)
						if m is not None:
							v['Disc Number'] = m.group(1)
							v['Track Number'] = m.group(2)
							v['Name'] = m.group(3)
						else:
							no_add['Disc Number'] = 1
							m = re.match(r'^([0-9][0-9]*)[ -](.*)$',value)
							if m is not None:
								v['Track Number'] = m.group(1)
								v['Name'] = m.group(2)
							else:
								v['Name'] = value
								no_add['Track Number'] = 1
					elif (key == 'Artist')or(key == 'Album')or(key == 'Track Number')or(key == 'Disc Number'):
						no_add[key] = 1
					elif key == 'Kind':
						if value[0:3] == 'WAV':
							wav_flag = 1
					elif key == 'Location':
						folder = value.split('/')
						v['Artist'] = urllib.unquote(folder[-3])
						v['Album'] = urllib.unquote(folder[-2])
					block.append(rec)
	else:
		print >> out_file, rec,
in_file.close()
out_file.close()

print 'WAV     track count %6d' % wav_count
print 'Not WAV track count %6d' % not_wav_count
print '====================================='
print 'Please Hit [Enter] key.'
raw_input()
